Bump configuration for Guppy 7.0.4
[AGL/meta-agl.git] / scripts / .aglsetup_genconfig.bash
index b0d24e5..599a5c3 100755 (executable)
@@ -4,7 +4,7 @@
 #
 # The MIT License (MIT)
 #
-# Copyright (c) 2016 Stéphane Desneux <sdx@iot.bzh>
+# Copyright (c) 2016-2019 Stéphane Desneux <sdx@iot.bzh>
 #           (c) 2016 Jan-Simon Möller <jsmoeller@linuxfoundation.org>
 #
 # Permission is hereby granted, free of charge, to any person obtaining a copy
 # turn execute (source) generated instructions back in the parent shell,
 # whether it's bash, zsh, or any other supported shell
 
-VERSION=1.1.0
+VERSION=1.2.0
 DEFAULT_MACHINE=qemux86-64
 DEFAULT_BUILDDIR=./build
 VERBOSE=0
-DEBUG=0
+SHOWVERSION=0
+: ${DEBUG:=false}
 
 #SCRIPT=$(basename $BASH_SOURCE)
 SCRIPT=aglsetup.sh
@@ -46,9 +47,9 @@ function info() { echo "$@" >&2; }
 function infon() { echo -n "$@" >&2; }
 function error() { echo "ERROR: $@" >&2; return 1; }
 function verbose() { [[ $VERBOSE == 1 ]] && echo "$@" >&2; return 0; }
-function debug() { [[ $DEBUG == 1 ]] && echo "DEBUG: $@" >&2; return 0;}
+function debug() { $DEBUG && echo "DEBUG: $@" >&2; return 0;}
 
-info "------------ $SCRIPT: Starting"
+debug "------------ $SCRIPT: starting with command line arguments: $@"
 
 #compute AGL_REPOSITORIES
 AGL_REPOSITORIES=$(for x in $(ls -d $METADIR/*/templates/{machine,feature}); do echo $(basename $(dirname $(dirname $x))); done | sort -u)
@@ -159,11 +160,22 @@ Options:
           'timestamp' : Use a generated time stamp (UTC).
           'value:<revision>' : Use <revision> explicitly.
           'none' : Do nothing.
+   -t|--topic <value>
+      Specify an optional topic for this setup.
+      If specified, the topic will be propagated in build manifests:
+         - in deployment dir: tmp/deploy/images/*/build-info
+         - in target image: /etc/platform-info/build
+         - in SDK: tmp/deploy/sdk/*.build-info
    -v|--verbose
       verbose mode
       default: false
+   -V|--version
+      display version, set AGLSETUP_VERSION variable with version value and exit
    -d|--debug
       debug mode
+      for early debug, set env variable DEBUG. 
+      for example:
+           DEBUG=true source aglsetup.sh -V
       default: false
    -h|--help
       get some help
@@ -213,6 +225,7 @@ function append_fragment() {
        echo "#" >>$basefile
        [[ -n "$label" ]] && echo "$label" >>$basefile
        [[ -f $f ]] && cat $f >>$basefile || true
+       echo "" >>$basefile
        echo "#" >>$basefile
        echo "# }" >>$basefile
        echo "# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #" >>$basefile
@@ -223,7 +236,7 @@ function execute_setup() {
        script=$1
        debug "Executing script $script"
        opts="-e"
-       [[ $DEBUG == 1 ]] && opts="$opts -x"
+       $DEBUG && opts="$opts -x"
        pushd $BUILDDIR &>/dev/null
                $BASH $opts $script \
                        && rc=0 \
@@ -290,7 +303,7 @@ function find_feature_dependency() {
 
 GLOBAL_ARGS=( "$@" )
 debug "Parsing arguments: $@"
-TEMP=$(getopt -o m:b:r:s:fvdh --long machine:,builddir:,rpm-revision:,script:,force,verbose,debug,help -n $SCRIPT -- "$@")
+TEMP=$(getopt -o m:b:r:t:s:fvVdh --long machine:,builddir:,rpm-revision:,topic:,script:,force,verbose,version,debug,help -n $SCRIPT -- "$@")
 [[ $? != 0 ]] && { usage; exit 1; }
 eval set -- "$TEMP"
 
@@ -302,6 +315,9 @@ BUILDDIR=$DEFAULT_BUILDDIR
 SETUPSCRIPT=
 FORCE=
 RPMREVISION=
+TOPIC=
+SETUP_MANIFEST=aglsetup.manifest
+
 while true; do
        case "$1" in
                -m|--machine)      MACHINE=$2; shift 2;;
@@ -309,8 +325,10 @@ while true; do
                -s|--setupscript)  SETUPSCRIPT=$2; shift 2;;
                -f|--force)        FORCE=1; shift;;
                -r|--rpm-revision) RPMREVISION=$2; shift 2;;
+               -t|--topic)        TOPIC=$2; shift 2;;
                -v|--verbose)      VERBOSE=1; shift;;
-               -d|--debug)        VERBOSE=1; DEBUG=1; shift;;
+               -V|--version)      SHOWVERSION=1; shift;;
+               -d|--debug)        VERBOSE=1; DEBUG=true; shift;;
                -h|--help)         HELP=1; shift;;
                --)                shift; break;;
                *) error "Arguments parsing error"; exit 1;;
@@ -319,6 +337,24 @@ done
 
 [[ "$HELP" == 1 ]] && { usage; exit 0; }
 
+if [[ "$SHOWVERSION" == 1 ]]; then
+       # display version on stdout
+       echo "$VERSION"
+
+       # generate output script if requested by caller
+       if [[ -n "$SETUPSCRIPT" ]]; then
+               cat <<EOF >$SETUPSCRIPT
+AGLSETUP_VERSION=$VERSION
+EOF
+       fi
+
+       # IMPORTANT: exit successfully
+       # older aglsetup scripts with version <1.2.0 will fail with option --version
+       exit 0
+fi
+
+info "------------ $SCRIPT: Starting"
+
 verbose "Command line arguments: ${GLOBAL_ARGS[@]}"
 
 # the remaining args are the features
@@ -407,6 +443,12 @@ function genconfig() {
                append_fragment $BUILDDIR/conf/local.conf $file
                verbose "      + $file"
        done
+       # special fragment to call distro-manifest-generator.sh from 
+       # meta-agl-profile-core/recipes-core/distro-build-manifest/distro-build-manifest.bb
+       append_fragment $BUILDDIR/conf/local.conf /dev/stdin "# generated by $(realpath $BASH_SOURCE)" <<-EOF
+               DISTRO_SETUP_MANIFEST = "$(realpath -Ls $BUILDDIR)/$SETUP_MANIFEST"
+               DISTRO_MANIFEST_GENERATOR = "$(dirname $(realpath $BASH_SOURCE))/distro-manifest-generator.sh"
+       EOF
 
        FRAGMENTS_SETUP=$(sed 's/ /\n/g' <<<$FRAGMENTS_SETUP | sort)
        debug "setup fragments: $FRAGMENTS_SETUP"
@@ -455,6 +497,8 @@ EOF
        $BUILDDIR/conf/setup.* \
        $BUILDDIR/conf/*.log
 
+####### step 1: generate configuration file #######
+
 if [[ -f $BUILDDIR/conf/local.conf || -f $BUILDDIR/conf/bblayers.conf ]]; then
        info "Configuration files already exist:"
        for x in $BUILDDIR/conf/local.conf $BUILDDIR/conf/bblayers.conf; do
@@ -466,6 +510,46 @@ else
        genconfig
 fi
 
+####### step 2: generate aglsetup.manifest #######
+
+infon "Generating setup manifest: $BUILDDIR/$SETUP_MANIFEST ... "
+for x in /etc/os-release /usr/lib/os-release; do
+       [[ -f $x ]] && . $x
+done
+FEATURES_md5=$(echo $FEATURES|md5sum -|awk '{print $1;}')
+cat <<EOF >$BUILDDIR/$SETUP_MANIFEST
+# ----------------------------------------------
+# This fragment has been generated by $SCRIPT at setup time
+
+# distro name
+DIST_DISTRO_NAME="AGL"
+
+# target machine as passed to $SCRIPT
+DIST_MACHINE="$MACHINE"
+
+# features as resolved by $SCRIPT
+DIST_FEATURES="$FEATURES"
+DIST_FEATURES_MD5="${FEATURES_md5}"
+
+# build host information deduced from os-release
+DIST_BUILD_HOST="$(id -un)@$(hostname -f || hostname || hostname -s)"
+DIST_BUILD_OS="${PRETTY_NAME:-${NAME} ${VERSION} [COMPUTED]}"
+
+# meta directory
+DIST_METADIR="$METADIR"
+
+# timestamp
+DIST_SETUP_TS="$(date -u +%Y%m%d_%H%M%S_%Z)"
+
+# topic
+DIST_SETUP_TOPIC="$TOPIC"
+
+# ------------ end of $SCRIPT fragment --------
+EOF
+info "OK"
+
+####### step 3: generate agl-init-build-env #######
+
 # always generate setup script in builddir: it can be sourced later manually without re-running the setup
 infon "Generating setup file: $BUILDDIR/agl-init-build-env ... "
 
@@ -482,6 +566,8 @@ unset TEMPLATECONF
 EOF
 info "OK"
 
+####### step 4: generate output script #######
+
 # finally, generate output script if requested by caller
 if [[ -n "$SETUPSCRIPT" ]]; then
        debug "generating setupscript in $SETUPSCRIPT"